import { NextRequest, NextResponse } from "next/server";
import { PageEvent, PublicUrl } from "./index";
import { NextApiRequest, NextApiResponse } from "next";
export declare const defaultCookieName = "_next-collect_id";
export declare type NextRequestShim<Req, Res> = {
    getAnonymousId: (cookieName: string | undefined | null, cookieDomain: string | undefined, req: Req, res: Res, url: PublicUrl) => string | undefined;
    getPageEvent: (eventType: string, url: PublicUrl, anonymousId: string | undefined, req: Req) => PageEvent<NextJsPageProps>;
    parsePublicUrl: (req: Req) => PublicUrl;
};
export declare type NextJsPageProps = {
    nextPrefetch: boolean | null;
};
export declare const nextApiShim: NextRequestShim<NextApiRequest, NextApiResponse>;
export declare const pageMiddlewareShim: NextRequestShim<NextRequest, NextResponse>;
